package biz.hammurapi.jms.adapter.tutorial;

import java.io.File;

import org.apache.xmlbeans.XmlObject;

import biz.hammurapi.jms.adapter.JmsAdapter;
import biz.hammurapi.jms.adapter.ProxyService;
import biz.hammurapi.jms.adapter.definition.JmsAdapterDocument;


public class ProxyServiceConsumer {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		XmlObject document = XmlObject.Factory.parse(new File("service-consumer.xml"));
		if (document instanceof JmsAdapterDocument) {
			biz.hammurapi.jms.adapter.definition.JmsAdapter definition = ((JmsAdapterDocument) document).getJmsAdapter();
			JmsAdapter adapter = new JmsAdapter(definition);
			adapter.start();
			try {
				ProxyService service = (ProxyService) adapter.get("proxy");
				StringLengthService proxy = (StringLengthService) service.createProxy();
				proxy.setValue("Hello");
				System.out.println(proxy.getValue());
				System.out.println(proxy.length());
			} finally {
				adapter.stop();
			}
		} else {
			System.err.println("Invalid adapter definition.");
		}
	}

}
