package biz.hammurapi.jms.adapter.tutorial;

import java.io.File;

import org.apache.xmlbeans.XmlObject;

import biz.hammurapi.jms.adapter.JmsAdapter;
import biz.hammurapi.jms.adapter.JmsService;
import biz.hammurapi.jms.adapter.definition.JmsAdapterDocument;


public class ServiceConsumer {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		XmlObject document = XmlObject.Factory.parse(new File("service-consumer.xml"));
		if (document instanceof JmsAdapterDocument) {
			biz.hammurapi.jms.adapter.definition.JmsAdapter definition = ((JmsAdapterDocument) document).getJmsAdapter();
			JmsAdapter adapter = new JmsAdapter(definition);
			adapter.start();
			try {
				JmsService service = (JmsService) adapter.get("connections/active-mq/services/string-length");
				System.out.println(service.request("Hello"));
				//System.out.println(service.request(new Integer(385)));
			} finally {
				adapter.stop();
			}
		} else {
			System.err.println("Invalid adapter definition.");
		}
	}

}
